diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_map.c xircd/src/m_map.c
--- ircd-hybrid-6.3/src/m_map.c	Wed Dec 31 19:00:00 1969
+++ xircd/src/m_map.c	Sat Apr 13 10:26:43 2002
@@ -0,0 +1,127 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, contrib/m_map.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_map.c,v 1.13 2002/04/13 14:26:43 reddawg Exp $
+ */
+
+#include <assert.h>
+#include "ircd.h"
+#include "config.h"
+#include "client.h"
+#include "numeric.h"
+#include "send.h"
+#include "s_conf.h"
+
+#define USER_COL       50 /* display | Users: %d at col 50 */
+
+static char buf[BUFSIZE];
+
+static void dump_map(struct Client *cptr,struct Client *root_p, char *pbuf);
+
+/* m_map
+**	parv[0] = sender prefix
+*/
+
+int m_map(struct Client *cptr, struct Client *sptr, int parc, char *parv[]) {
+  dump_map(cptr,&me,buf);
+  sendto_one(cptr, form_str(RPL_MAPEND), me.name, cptr->name);
+  return;
+  return;
+  }
+
+/*
+** mo_map
+**      parv[0] = sender prefix
+*/
+static void mo_map(struct Client *cptr, struct Client *sptr,
+                    int parc, char *parv[])
+{
+  dump_map(cptr,&me,buf);
+  sendto_one(cptr, form_str(RPL_MAPEND), me.name, cptr->name);
+}
+
+/*
+** dump_map
+**   dumps server map, called recursively.
+*/
+static void dump_map(struct Client *cptr,struct Client *root_p, char *pbuf)
+{
+  int cnt = 0, i = 0, len;
+  int users = 0;
+  struct Client *server_p,*user_p;
+        
+  *pbuf= '\0';
+       
+  strncat(pbuf,root_p->name,BUFSIZE - ((size_t) pbuf - (size_t) buf));
+  len = strlen(buf);
+  buf[len] = ' ';
+	
+  if (len < USER_COL)
+  {
+     for (i = len+1; i < USER_COL; i++)
+     {
+       buf[i] = ' ';
+     }
+  }
+	
+  /* FIXME: add serv->usercnt */
+  for( user_p = root_p->serv->users; user_p; user_p = user_p->lnext )
+    users++;
+  snprintf(buf + USER_COL, BUFSIZE - USER_COL,
+           " Users: %5d (%4.1f%%)", users,
+           100 * (float) users / (float) Count.total);
+        
+  sendto_one(cptr, form_str(RPL_MAP),me.name,cptr->name,buf);
+        
+  if ((server_p = root_p->serv->servers))
+  {
+    for (; server_p; server_p = server_p->lnext)
+    {
+      cnt++;
+    }
+    
+    if (cnt)
+    {
+      if (pbuf > buf + 3)
+      {
+        pbuf[-2] = ' ';
+        if (pbuf[-3] == '`')
+          pbuf[-3] = ' ';
+      }
+    }
+  }
+  for (i = 1,server_p = root_p->serv->servers; server_p; server_p=server_p->lnext)
+  {
+    *pbuf = ' ';
+    if (i < cnt)
+      *(pbuf + 1) = '|';
+    else
+      *(pbuf + 1) = '`';
+      
+    *(pbuf + 2) = '-';
+    *(pbuf + 3) = ' ';
+    dump_map(cptr,server_p,pbuf+4);
+ 
+    i++;
+   }
+}
+
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_message.c xircd/src/m_message.c
--- ircd-hybrid-6.3/src/m_message.c	Sat Dec 22 19:06:14 2001
+++ xircd/src/m_message.c	Tue Apr  9 10:00:51 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_message.c,v 1.18 2001/12/23 00:06:14 lusky Exp $
+ *   $Id: m_message.c,v 1.1.1.1 2002/04/09 14:00:51 reddawg Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_mode.c xircd/src/m_mode.c
--- ircd-hybrid-6.3/src/m_mode.c	Fri Jul 30 22:42:56 1999
+++ xircd/src/m_mode.c	Tue Apr  9 10:00:51 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_mode.c,v 1.1 1999/07/31 02:42:56 tomh Exp $
+ *   $Id: m_mode.c,v 1.1.1.1 2002/04/09 14:00:51 reddawg Exp $
  */
 #include "m_commands.h"
 #include "channel.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_oper.c xircd/src/m_oper.c
--- ircd-hybrid-6.3/src/m_oper.c	Sat Dec  8 02:06:13 2001
+++ xircd/src/m_oper.c	Tue Apr  9 10:00:51 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_oper.c,v 1.16 2001/12/08 07:06:13 lusky Exp $
+ *   $Id: m_oper.c,v 1.1.1.1 2002/04/09 14:00:51 reddawg Exp $
  */
 
 #include "m_commands.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_operwall.c xircd/src/m_operwall.c
--- ircd-hybrid-6.3/src/m_operwall.c	Wed Oct 17 11:13:31 2001
+++ xircd/src/m_operwall.c	Tue Apr  9 10:00:51 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_operwall.c,v 1.3 2001/10/17 15:13:31 db Exp $
+ *   $Id: m_operwall.c,v 1.1.1.1 2002/04/09 14:00:51 reddawg Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_pass.c xircd/src/m_pass.c
--- ircd-hybrid-6.3/src/m_pass.c	Sun Jun  3 21:31:33 2001
+++ xircd/src/m_pass.c	Tue Apr  9 10:00:51 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: m_pass.c,v 1.4 2001/06/04 01:31:33 greg Exp $
+ *  $Id: m_pass.c,v 1.1.1.1 2002/04/09 14:00:51 reddawg Exp $
  */
 #include "m_commands.h"  /* m_pass prototype */
 #include "client.h"      /* client struct */
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_ping.c xircd/src/m_ping.c
--- ircd-hybrid-6.3/src/m_ping.c	Thu Jul 29 23:25:51 1999
+++ xircd/src/m_ping.c	Tue Apr  9 10:00:51 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_ping.c,v 1.1 1999/07/30 03:25:51 db Exp $
+ *   $Id: m_ping.c,v 1.1.1.1 2002/04/09 14:00:51 reddawg Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_pong.c xircd/src/m_pong.c
--- ircd-hybrid-6.3/src/m_pong.c	Thu Nov 29 01:44:29 2001
+++ xircd/src/m_pong.c	Tue Apr  9 10:00:51 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_pong.c,v 1.3 2001/11/29 06:44:29 db Exp $
+ *   $Id: m_pong.c,v 1.1.1.1 2002/04/09 14:00:51 reddawg Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_quit.c xircd/src/m_quit.c
--- ircd-hybrid-6.3/src/m_quit.c	Sat Dec  8 02:06:14 2001
+++ xircd/src/m_quit.c	Tue Apr  9 10:00:51 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_quit.c,v 1.2 2001/12/08 07:06:14 lusky Exp $
+ *   $Id: m_quit.c,v 1.1.1.1 2002/04/09 14:00:51 reddawg Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_rehash.c xircd/src/m_rehash.c
--- ircd-hybrid-6.3/src/m_rehash.c	Thu Dec  6 23:51:34 2001
+++ xircd/src/m_rehash.c	Tue Apr  9 10:00:51 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_rehash.c,v 1.9 2001/12/07 04:51:34 wcampbel Exp $
+ *   $Id: m_rehash.c,v 1.1.1.1 2002/04/09 14:00:51 reddawg Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_restart.c xircd/src/m_restart.c
--- ircd-hybrid-6.3/src/m_restart.c	Sat Dec  8 02:06:14 2001
+++ xircd/src/m_restart.c	Tue Apr  9 10:00:51 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_restart.c,v 1.5 2001/12/08 07:06:14 lusky Exp $
+ *   $Id: m_restart.c,v 1.1.1.1 2002/04/09 14:00:51 reddawg Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_server.c xircd/src/m_server.c
--- ircd-hybrid-6.3/src/m_server.c	Sun Jun 17 19:51:21 2001
+++ xircd/src/m_server.c	Tue Apr  9 10:00:51 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_server.c,v 1.14 2001/06/17 23:51:21 greg Exp $
+ *   $Id: m_server.c,v 1.1.1.1 2002/04/09 14:00:51 reddawg Exp $
  */
 #include "m_commands.h"  /* m_server prototype */
 #include "client.h"      /* client struct */
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_set.c xircd/src/m_set.c
--- ircd-hybrid-6.3/src/m_set.c	Thu Dec 13 18:50:45 2001
+++ xircd/src/m_set.c	Tue Apr  9 10:00:51 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_set.c,v 1.7 2001/12/13 23:50:45 db Exp $
+ *   $Id: m_set.c,v 1.1.1.1 2002/04/09 14:00:51 reddawg Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_squit.c xircd/src/m_squit.c
--- ircd-hybrid-6.3/src/m_squit.c	Thu Jul 26 12:04:31 2001
+++ xircd/src/m_squit.c	Tue Apr  9 10:00:52 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_squit.c,v 1.4 2001/07/26 16:04:31 leeh Exp $
+ *   $Id: m_squit.c,v 1.1.1.1 2002/04/09 14:00:52 reddawg Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_stats.c xircd/src/m_stats.c
--- ircd-hybrid-6.3/src/m_stats.c	Wed Dec 19 18:24:46 2001
+++ xircd/src/m_stats.c	Tue Apr  9 10:00:52 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: m_stats.c,v 1.21 2001/12/19 23:24:46 leeh Exp $
+ *  $Id: m_stats.c,v 1.1.1.1 2002/04/09 14:00:52 reddawg Exp $
  */
 #include "m_commands.h"  /* m_pass prototype */
 #include "class.h"       /* report_classes */
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_svinfo.c xircd/src/m_svinfo.c
--- ircd-hybrid-6.3/src/m_svinfo.c	Fri Jul 27 20:49:52 2001
+++ xircd/src/m_svinfo.c	Tue Apr  9 10:00:52 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_svinfo.c,v 1.6 2001/07/28 00:49:52 leeh Exp $
+ *   $Id: m_svinfo.c,v 1.1.1.1 2002/04/09 14:00:52 reddawg Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_time.c xircd/src/m_time.c
--- ircd-hybrid-6.3/src/m_time.c	Fri Jul 30 02:40:16 1999
+++ xircd/src/m_time.c	Tue Apr  9 10:00:52 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_time.c,v 1.1 1999/07/30 06:40:16 tomh Exp $
+ *   $Id: m_time.c,v 1.1.1.1 2002/04/09 14:00:52 reddawg Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_trace.c xircd/src/m_trace.c
--- ircd-hybrid-6.3/src/m_trace.c	Wed Dec 19 18:02:06 2001
+++ xircd/src/m_trace.c	Tue Apr  9 10:00:52 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_trace.c,v 1.12 2001/12/19 23:02:06 leeh Exp $
+ *   $Id: m_trace.c,v 1.1.1.1 2002/04/09 14:00:52 reddawg Exp $
  */
 #include "m_commands.h"
 #include "class.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_unkline.c xircd/src/m_unkline.c
--- ircd-hybrid-6.3/src/m_unkline.c	Sun Feb 17 00:58:13 2002
+++ xircd/src/m_unkline.c	Tue Apr  9 10:00:52 2002
@@ -21,7 +21,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- *   $Id: m_unkline.c,v 1.45 2002/02/17 05:58:13 lusky Exp $
+ *   $Id: m_unkline.c,v 1.1.1.1 2002/04/09 14:00:52 reddawg Exp $
  */
 #include "m_commands.h"
 #include "channel.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_userhost.c xircd/src/m_userhost.c
--- ircd-hybrid-6.3/src/m_userhost.c	Tue Jan  2 00:48:18 2001
+++ xircd/src/m_userhost.c	Tue Apr  9 10:00:52 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_userhost.c,v 1.10 2001/01/02 05:48:18 lusky Exp $
+ *   $Id: m_userhost.c,v 1.1.1.1 2002/04/09 14:00:52 reddawg Exp $
  */
 
 #include "m_commands.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_users.c xircd/src/m_users.c
--- ircd-hybrid-6.3/src/m_users.c	Thu Jul 29 03:11:49 1999
+++ xircd/src/m_users.c	Tue Apr  9 10:00:52 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_users.c,v 1.1 1999/07/29 07:11:49 tomh Exp $
+ *   $Id: m_users.c,v 1.1.1.1 2002/04/09 14:00:52 reddawg Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_version.c xircd/src/m_version.c
--- ircd-hybrid-6.3/src/m_version.c	Thu Dec 20 16:25:48 2001
+++ xircd/src/m_version.c	Tue Apr  9 10:00:52 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_version.c,v 1.11 2001/12/20 21:25:48 leeh Exp $
+ *   $Id: m_version.c,v 1.1.1.1 2002/04/09 14:00:52 reddawg Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_wallops.c xircd/src/m_wallops.c
--- ircd-hybrid-6.3/src/m_wallops.c	Wed Oct 17 11:13:31 2001
+++ xircd/src/m_wallops.c	Tue Apr  9 10:00:52 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_wallops.c,v 1.3 2001/10/17 15:13:31 db Exp $
+ *   $Id: m_wallops.c,v 1.1.1.1 2002/04/09 14:00:52 reddawg Exp $
  */
 #include "m_commands.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_who.c xircd/src/m_who.c
--- ircd-hybrid-6.3/src/m_who.c	Fri Nov 24 12:36:30 2000
+++ xircd/src/m_who.c	Tue Apr  9 10:00:52 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_who.c,v 1.3 2000/11/24 17:36:30 lusky Exp $
+ *   $Id: m_who.c,v 1.1.1.1 2002/04/09 14:00:52 reddawg Exp $
  */
 
 #include "m_commands.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/m_whois.c xircd/src/m_whois.c
--- ircd-hybrid-6.3/src/m_whois.c	Wed Jun  6 02:56:34 2001
+++ xircd/src/m_whois.c	Tue Apr  9 10:00:52 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: m_whois.c,v 1.7 2001/06/06 06:56:34 db Exp $
+ *   $Id: m_whois.c,v 1.1.1.1 2002/04/09 14:00:52 reddawg Exp $
  */
 
 #include "m_commands.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/match.c xircd/src/match.c
--- ircd-hybrid-6.3/src/match.c	Sat Dec  8 02:06:14 2001
+++ xircd/src/match.c	Tue Apr  9 10:00:53 2002
@@ -22,7 +22,7 @@
  * Cleanup of collapse and match
  * Moved static calls variable to match
  * Added asserts for null pointers
- * $Id: match.c,v 1.28 2001/12/08 07:06:14 lusky Exp $
+ * $Id: match.c,v 1.1.1.1 2002/04/09 14:00:53 reddawg Exp $
  *
  */
 #include "irc_string.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/messages.tab xircd/src/messages.tab
--- ircd-hybrid-6.3/src/messages.tab	Sat Dec 29 22:25:48 2001
+++ xircd/src/messages.tab	Wed Apr 10 18:48:15 2002
@@ -19,7 +19,7 @@
  *
  *      I kind of modernized this code a bit. -Dianora
  *
- *   $Id: messages.tab,v 1.24 2001/12/30 03:25:48 lusky Exp $
+ *   $Id: messages.tab,v 1.2 2002/04/10 22:48:15 reddawg Exp $
  */
 
 static  char *  replies[] = {
@@ -38,9 +38,9 @@
 /* 012 */       NULL,
 /* 013 */       NULL,
 /* 014 */       NULL,
-/* 015 */       NULL,
+/* 015 */       ":%s 015 %s :%s",
 /* 016 */       NULL,
-/* 017 */       NULL,
+/* 017 */       ":%s 017 %s :End of /MAP",
 /* 018 */       NULL,
 /* 019 */       NULL,
 /* 020 */       NULL,
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/messages_cust.tab xircd/src/messages_cust.tab
--- ircd-hybrid-6.3/src/messages_cust.tab	Sat Dec 29 22:25:48 2001
+++ xircd/src/messages_cust.tab	Tue Apr  9 10:00:53 2002
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- * $Id: messages_cust.tab,v 1.23 2001/12/30 03:25:48 lusky Exp $
+ * $Id: messages_cust.tab,v 1.1.1.1 2002/04/09 14:00:53 reddawg Exp $
  *
  */
 /* 
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/motd.c xircd/src/motd.c
--- ircd-hybrid-6.3/src/motd.c	Tue Jul 17 21:37:15 2001
+++ xircd/src/motd.c	Tue Apr  9 10:00:53 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: motd.c,v 1.24 2001/07/18 01:37:15 lusky Exp $
+ *   $Id: motd.c,v 1.1.1.1 2002/04/09 14:00:53 reddawg Exp $
  */
 #include "m_commands.h"
 #include "motd.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/mtrie_conf.c xircd/src/mtrie_conf.c
--- ircd-hybrid-6.3/src/mtrie_conf.c	Wed Dec 19 18:02:06 2001
+++ xircd/src/mtrie_conf.c	Tue Apr  9 10:00:53 2002
@@ -43,7 +43,7 @@
  *
  * Diane Bruce -db (db@db.net)
  *
- * $Id: mtrie_conf.c,v 1.87 2001/12/19 23:02:06 leeh Exp $
+ * $Id: mtrie_conf.c,v 1.1.1.1 2002/04/09 14:00:53 reddawg Exp $
  */
 #include "mtrie_conf.h"
 #include "class.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/numeric.c xircd/src/numeric.c
--- ircd-hybrid-6.3/src/numeric.c	Wed Nov 21 20:19:21 2001
+++ xircd/src/numeric.c	Tue Apr  9 10:00:53 2002
@@ -19,7 +19,7 @@
  *
  *      I kind of modernized this code a bit. -Dianora
  *
- *   $Id: numeric.c,v 1.4 2001/11/22 01:19:21 db Exp $
+ *   $Id: numeric.c,v 1.1.1.1 2002/04/09 14:00:53 reddawg Exp $
  */
 #include "numeric.h"
 #include "irc_string.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/packet.c xircd/src/packet.c
--- ircd-hybrid-6.3/src/packet.c	Sun Dec  9 21:56:29 2001
+++ xircd/src/packet.c	Tue Apr  9 10:00:53 2002
@@ -18,7 +18,7 @@
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
  *
- *   $Id: packet.c,v 1.25 2001/12/10 02:56:29 jdc Exp $
+ *   $Id: packet.c,v 1.1.1.1 2002/04/09 14:00:53 reddawg Exp $
  */ 
 #include "packet.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/parse.c xircd/src/parse.c
--- ircd-hybrid-6.3/src/parse.c	Sat Dec 29 22:25:48 2001
+++ xircd/src/parse.c	Tue Apr  9 10:00:54 2002
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: parse.c,v 1.47 2001/12/30 03:25:48 lusky Exp $
+ *   $Id: parse.c,v 1.1.1.1 2002/04/09 14:00:54 reddawg Exp $
  */
 #include "parse.h"
 #include "channel.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/restart.c xircd/src/restart.c
--- ircd-hybrid-6.3/src/restart.c	Sat Dec  8 02:06:14 2001
+++ xircd/src/restart.c	Tue Apr  9 10:00:54 2002
@@ -1,7 +1,7 @@
 /*
  * restart.c
  *
- * $Id: restart.c,v 1.11 2001/12/08 07:06:14 lusky Exp $
+ * $Id: restart.c,v 1.1.1.1 2002/04/09 14:00:54 reddawg Exp $
  */
 #include "restart.h"
 #include "common.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/s_auth.c xircd/src/s_auth.c
--- ircd-hybrid-6.3/src/s_auth.c	Tue Dec  4 02:44:37 2001
+++ xircd/src/s_auth.c	Tue Apr  9 10:00:54 2002
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_auth.c,v 1.52 2001/12/04 07:44:37 androsyn Exp $
+ *   $Id: s_auth.c,v 1.1.1.1 2002/04/09 14:00:54 reddawg Exp $
  *
  * Changes:
  *   July 6, 1999 - Rewrote most of the code here. When a client connects
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/s_bsd.c xircd/src/s_bsd.c
--- ircd-hybrid-6.3/src/s_bsd.c	Tue Feb  5 23:56:12 2002
+++ xircd/src/s_bsd.c	Tue Apr  9 10:00:54 2002
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_bsd.c,v 1.147 2002/02/06 04:56:12 androsyn Exp $
+ *  $Id: s_bsd.c,v 1.1.1.1 2002/04/09 14:00:54 reddawg Exp $
  */
 #include "s_bsd.h"
 #include "class.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/s_conf.c xircd/src/s_conf.c
--- ircd-hybrid-6.3/src/s_conf.c	Sun Feb 17 00:58:13 2002
+++ xircd/src/s_conf.c	Sat Apr 13 19:50:12 2002
@@ -19,7 +19,7 @@
  *
  *  (C) 1988 University of Oulu,Computing Center and Jarkko Oikarinen"
  *
- *  $Id: s_conf.c,v 1.236 2002/02/17 05:58:13 lusky Exp $
+ *  $Id: s_conf.c,v 1.2 2002/04/13 23:50:12 icedruid Exp $
  */
 #include "m_commands.h"
 #include "s_conf.h"
@@ -404,6 +404,7 @@
  * -3 = I-line is full
  * -4 = Too many connections from hostname
  * -5 = K-lined
+ * -6 = Excessive clones
  * also updates reason if a K-line
  *
  */
@@ -530,6 +531,30 @@
   IP_ENTRY *ip_found;
 
   /* if LIMIT_UH is set, limit clients by idented usernames not by ip */
+
+	/* Check if the I:line has a global user limit in place. - Allanon */
+	if (aconf->port > 0)
+	{
+		aClient *acptr;
+		unsigned count = 1;
+
+		for (acptr = GlobalClientList; acptr; acptr = acptr->next)
+		{
+			if (!IsRegisteredUser(acptr))
+				continue;
+		
+			/*
+			 * Do a hostname compare (as registered) to check for clones.
+			 * This will allow us to support multiple vanity hosts from
+			 * the same IP (if so desired). - Allanon
+			 */
+			if (!irccmp(cptr->host, acptr->host))
+				count++;
+		}
+
+		if (count > aconf->port)
+	        return -6;		
+	}
 
   ip_found = find_or_add_ip(cptr, username);
 
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/s_debug.c xircd/src/s_debug.c
--- ircd-hybrid-6.3/src/s_debug.c	Sun Dec 16 00:49:19 2001
+++ xircd/src/s_debug.c	Tue Apr  9 10:00:55 2002
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_debug.c,v 1.59 2001/12/16 05:49:19 wcampbel Exp $
+ *   $Id: s_debug.c,v 1.1.1.1 2002/04/09 14:00:55 reddawg Exp $
  */
 #include "s_debug.h"
 #include "channel.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/s_log.c xircd/src/s_log.c
--- ircd-hybrid-6.3/src/s_log.c	Sat Feb  2 10:52:20 2002
+++ xircd/src/s_log.c	Tue Apr  9 10:00:55 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_log.c,v 1.14 2002/02/02 15:52:20 db Exp $
+ *   $Id: s_log.c,v 1.1.1.1 2002/04/09 14:00:55 reddawg Exp $
  */
 #include "s_log.h"
 #include "irc_string.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/s_misc.c xircd/src/s_misc.c
--- ircd-hybrid-6.3/src/s_misc.c	Sun Feb 17 13:16:03 2002
+++ xircd/src/s_misc.c	Tue Apr  9 10:00:55 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_misc.c,v 1.74 2002/02/17 18:16:03 lusky Exp $
+ *  $Id: s_misc.c,v 1.1.1.1 2002/04/09 14:00:55 reddawg Exp $
  */
 #include "s_misc.h"
 #include "channel.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/s_serv.c xircd/src/s_serv.c
--- ircd-hybrid-6.3/src/s_serv.c	Sun Dec  9 21:56:29 2001
+++ xircd/src/s_serv.c	Tue Apr  9 10:00:55 2002
@@ -19,7 +19,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_serv.c,v 1.229 2001/12/10 02:56:29 jdc Exp $
+ *   $Id: s_serv.c,v 1.1.1.1 2002/04/09 14:00:55 reddawg Exp $
  */
 #include "s_serv.h"
 #include "channel.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/s_stats.c xircd/src/s_stats.c
--- ircd-hybrid-6.3/src/s_stats.c	Fri Jul 30 16:10:54 1999
+++ xircd/src/s_stats.c	Tue Apr  9 10:00:55 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_stats.c,v 1.1 1999/07/30 20:10:54 tomh Exp $
+ *  $Id: s_stats.c,v 1.1.1.1 2002/04/09 14:00:55 reddawg Exp $
  */
 #include "s_stats.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/s_user.c xircd/src/s_user.c
--- ircd-hybrid-6.3/src/s_user.c	Wed Jan 23 13:39:08 2002
+++ xircd/src/s_user.c	Sat Apr 13 19:50:12 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_user.c,v 1.248 2002/01/23 18:39:08 androsyn Exp $
+ *  $Id: s_user.c,v 1.2 2002/04/13 23:50:12 icedruid Exp $
  */
 #include "m_commands.h"
 #include "s_user.h"
@@ -532,6 +532,7 @@
 #define I_LINE_FULL     (-3)
 #define I_LINE_FULL2    (-4)
 #define BANNED_CLIENT   (-5)
+#define I_LINE_CLONES   (-6)
 
   if (MyConnect(sptr))
     {
@@ -552,6 +553,16 @@
           return exit_client(cptr, sptr, &me, 
                  "No more connections allowed in your connection class" );
           break;
+
+	case I_LINE_CLONES:
+          sendto_realops_flags(FLAGS_FULL, "%s for %s (%s).",
+                               "Excessive clones detected",
+                               get_client_host(sptr),
+                               inetntoa((char*) &sptr->ip));
+          log(L_INFO,"Too many connections from %s.", get_client_host(sptr));
+          ServerStats->is_ref++;
+          return exit_client(cptr, sptr, &me, "No more connections allowed from your host" );
+	  break;
 
         case NOT_AUTHORIZED:
 
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/s_zip.c xircd/src/s_zip.c
--- ircd-hybrid-6.3/src/s_zip.c	Mon Jun  4 01:07:19 2001
+++ xircd/src/s_zip.c	Tue Apr  9 10:00:56 2002
@@ -16,7 +16,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_zip.c,v 1.25 2001/06/04 05:07:19 db Exp $
+ *   $Id: s_zip.c,v 1.1.1.1 2002/04/09 14:00:56 reddawg Exp $
  */
 #include "client.h"
 #include "s_zip.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/scache.c xircd/src/scache.c
--- ircd-hybrid-6.3/src/scache.c	Tue Jul 17 21:37:18 2001
+++ xircd/src/scache.c	Tue Apr  9 10:00:56 2002
@@ -1,7 +1,7 @@
 /*
  * scache.c
  *
- * $Id: scache.c,v 1.17 2001/07/18 01:37:18 lusky Exp $
+ * $Id: scache.c,v 1.1.1.1 2002/04/09 14:00:56 reddawg Exp $
  */
 
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/send.c xircd/src/send.c
--- ircd-hybrid-6.3/src/send.c	Sat Feb  2 15:58:30 2002
+++ xircd/src/send.c	Tue Apr  9 10:00:57 2002
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: send.c,v 1.112 2002/02/02 20:58:30 db Exp $
+ *   $Id: send.c,v 1.1.1.1 2002/04/09 14:00:57 reddawg Exp $
  */
 #include "send.h"
 #include "channel.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/sprintf_irc.c xircd/src/sprintf_irc.c
--- ircd-hybrid-6.3/src/sprintf_irc.c	Sat Dec  8 12:55:06 2001
+++ xircd/src/sprintf_irc.c	Tue Apr  9 10:00:57 2002
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: sprintf_irc.c,v 1.11 2001/12/08 17:55:06 db Exp $
+ *   $Id: sprintf_irc.c,v 1.1.1.1 2002/04/09 14:00:57 reddawg Exp $
  */
 #include "sprintf_irc.h"
 
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/version.c.SH xircd/src/version.c.SH
--- ircd-hybrid-6.3/src/version.c.SH	Sat Dec  8 00:10:22 2001
+++ xircd/src/version.c.SH	Wed Apr 10 18:52:17 2002
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-# $Id: version.c.SH,v 1.25 2001/12/08 05:10:22 jdc Exp $
+# $Id: version.c.SH,v 1.2 2002/04/10 22:52:17 reddawg Exp $
 
 spitshell=cat
 package=IRC
@@ -74,7 +74,7 @@
 
 IFS='
 '
-for i in `cat ../Hybrid-team | tr -d '"'` ; do
+for i in `cat ../Xnet-team | tr -d '"'` ; do
 echo "  \"$i\"," >> version.c
 done
 $spitshell >>version.c <<!SUB!THISTOO!
diff -uNrd -x ChangeLog ircd-hybrid-6.3/src/whowas.c xircd/src/whowas.c
--- ircd-hybrid-6.3/src/whowas.c	Tue Jul 17 22:30:34 2001
+++ xircd/src/whowas.c	Tue Apr  9 10:00:57 2002
@@ -16,7 +16,7 @@
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
-*   $Id: whowas.c,v 1.34 2001/07/18 02:30:34 lusky Exp $
+*   $Id: whowas.c,v 1.1.1.1 2002/04/09 14:00:57 reddawg Exp $
 */
 #include "whowas.h"
 #include "client.h"
diff -uNrd -x ChangeLog ircd-hybrid-6.3/tools/README xircd/tools/README
--- ircd-hybrid-6.3/tools/README	Fri Dec  7 20:59:19 2001
+++ xircd/tools/README	Tue Apr  9 10:00:57 2002
@@ -1,4 +1,4 @@
-$Id: README,v 1.6 2001/12/08 01:59:19 wcampbel Exp $
+$Id: README,v 1.1.1.1 2002/04/09 14:00:57 reddawg Exp $
 
 A directory of support programs for ircd.
 
diff -uNrd -x ChangeLog ircd-hybrid-6.3/tools/fixklines.c xircd/tools/fixklines.c
--- ircd-hybrid-6.3/tools/fixklines.c	Sat Dec  8 02:06:18 2001
+++ xircd/tools/fixklines.c	Tue Apr  9 10:00:57 2002
@@ -1,6 +1,6 @@
 /*
 fixklines - scan an ircd.conf or kline.conf file
-$Id: fixklines.c,v 1.5 2001/12/08 07:06:18 lusky Exp $
+$Id: fixklines.c,v 1.1.1.1 2002/04/09 14:00:57 reddawg Exp $
 
   D lines of form
   D:192.168.0.* are converted to D:192.168.0.0/24
diff -uNrd -x ChangeLog ircd-hybrid-6.3/tools/install_ircd xircd/tools/install_ircd
--- ircd-hybrid-6.3/tools/install_ircd	Tue Jul  3 17:52:19 2001
+++ xircd/tools/install_ircd	Sun Apr 28 09:36:37 2002
@@ -1,6 +1,8 @@
+# $Id: install_ircd,v 1.2 2002/04/28 13:36:37 reddawg Exp $
+
 #!/bin/sh
 # IRCD INSTALL SCRIPT
-# $Id: install_ircd,v 1.9 2001/07/03 21:52:19 wcampbel Exp $
+# $Id: install_ircd,v 1.2 2002/04/28 13:36:37 reddawg Exp $
 #
 # Completely re-written by FlashMan <chuegen@quadrunner.com> 981231
 # Wow.  The old version was *very* messy and had boatloads of redundancy.
@@ -9,6 +11,7 @@
 
 # Path to install-sh
 INSTALL_SH="autoconf/install-sh"
+DPATH=/usr/home/xnet/ircd/
 
 #
 # dir_concat looks to see if we have an absolute or relative path
@@ -39,7 +42,6 @@
   fi
 }
 
-DPATH=`grep '#define.DPATH' include/config.h|awk '{print $3}'|tr -d \"`;
 SPATH=`grep '#define.SPATH' include/config.h|awk '{print $3}'|tr -d \"`;
 CPATH=`grep '#define.CPATH' include/config.h|awk '{print $3}'|tr -d \"`;
 KPATH=`grep '#define.KPATH' include/config.h|awk '{print $3}'|tr -d \"`;
